Index: sasmodels/models/core_shell_bicelle.py
===================================================================
--- sasmodels/models/core_shell_bicelle.py	(revision 8007311db20a23588c62551c8a69f089cf8835e1)
+++ sasmodels/models/core_shell_bicelle.py	(revision 8007311db20a23588c62551c8a69f089cf8835e1)
@@ -0,0 +1,151 @@
+r"""
+
+Definition
+----------
+This model provides the form factor for a circular cylinder with a core-shell
+scattering length density profile.
+The form factor is normalized by the particle volume.
+
+.. _core-shell-cylinder-geometry:
+
+.. figure:: img/core_shell_bicelle_geometry.png
+
+    (Graphic from DOI: 10.1039/C0NP00002G)
+
+
+The output of the 1D scattering intensity function for randomly oriented
+cylinders is then given by the equation above.
+
+The *theta* and *phi* parameters are not used for the 1D output.
+Our implementation of the scattering kernel and the 1D scattering intensity
+use the c-library from NIST.
+
+.. figure:: img/core_shell_bicelle_1d.jpg
+
+    1D plot using the default values (w/200 data point).
+
+.. figure:: img/core_shell_bicelle_fig1.jpg
+
+    Definition of the angles for the oriented CoreShellBicelleModel.
+
+.. figure:: img/core_shell_bicelle_fig2.jpg
+
+    Examples of the angles for oriented pp against the detector plane.
+
+References
+----------
+
+L A Feigin and D I Svergun,
+*Structure Analysis by Small-Angle X-Ray and Neutron Scattering,*
+Plenum Press, New York, (1987)
+
+"""
+
+from numpy import inf, sin, cos
+
+name = "core_shell_bicelle"
+title = "Circular cylinder with a core-shell scattering length density profile.."
+description = """
+    P(q,alpha)= scale/Vs*f(q)^(2) + bkg,  where: f(q)= 2(core_sld
+    - solvant_sld)* Vc*sin[qLcos(alpha/2)]
+    /[qLcos(alpha/2)]*J1(qRsin(alpha))
+    /[qRsin(alpha)]+2(shell_sld-solvent_sld)
+    *Vs*sin[q(L+T)cos(alpha/2)][[q(L+T)
+    *cos(alpha/2)]*J1(q(R+T)sin(alpha))
+    /q(R+T)sin(alpha)]
+
+    alpha:is the angle between the axis of
+    the cylinder and the q-vector
+    Vs: the volume of the outer shell
+    Vc: the volume of the core
+    L: the length of the core
+    shell_sld: the scattering length density
+    of the shell
+    solvent_sld: the scattering length density
+    of the solvent
+    bkg: the background
+    T: the thickness
+    R+T: is the outer radius
+    L+2T: The total length of the outershell
+    J1: the first order Bessel function
+    theta: axis_theta of the cylinder
+    phi: the axis_phi of the cylinder...
+        """
+category = "shape:cylinder"
+
+# pylint: disable=bad-whitespace, line-too-long
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [
+    ["radius",         "Ang",       20, [0, inf],    "volume",      "Cylinder core radius"],
+    ["rim_thickness",  "Ang",       10, [0, inf],    "volume",      "Rim shell thickness"],
+    ["face_thickness", "Ang",       10, [0, inf],    "volume",      "Cylinder face thickness"],
+    ["length",         "Ang",      400, [0, inf],    "volume",      "Cylinder length"],
+    ["core_sld",       "1e-6/Ang^2", 1, [-inf, inf], "",            "Cylinder core scattering length density"],
+    ["face_sld",       "1e-6/Ang^2", 4, [-inf, inf], "",            "Cylinder face scattering length density"],
+    ["rim_sld",        "1e-6/Ang^2", 4, [-inf, inf], "",            "Cylinder rim scattering length density"],
+    ["solvent_sld",    "1e-6/Ang^2", 1, [-inf, inf], "",            "Solvent scattering length density"],
+    ["theta",          "degrees",   90, [-inf, inf], "orientation", "In plane angle"],
+    ["phi",            "degrees",    0, [-inf, inf], "orientation", "Out of plane angle"],
+    ]
+
+# pylint: enable=bad-whitespace, line-too-long
+
+source = ["lib/J1.c", "lib/gauss76.c", "core_shell_bicelle.c"]
+
+demo = dict(scale=1, background=0,
+            radius=20.0,
+            rim_thickness=10.0,
+            face_thickness=10.0,
+            length=400.0,
+            core_sld=1.0,
+            face_sld=4.0,
+            rim_sld=4.0,
+            solvent_sld=1.0,
+            theta=90,
+            phi=0)
+
+oldname = 'CoreShellBicelleModel'
+
+oldpars = dict(rim_thickness='rim_thick',
+               face_thickness='face_thick',
+               theta='axis_theta',
+               phi='axis_phi')
+
+qx, qy = 0.4 * cos(90), 0.5 * sin(0)
+tests = [
+    # Accuracy tests based on content in test/utest_other_models.py
+    [{'radius': 20.0,
+      'rim_thickness': 10.0,
+      'face_thickness': 10.0,
+      'length': 400.0,
+      'core_sld': 1.0,
+      'face_sld': 4.0,
+      'rim_sld': 4.0,
+      'solvent_sld': 1.0,
+      'background': 0.0,
+     }, 0.001, 353.550],
+
+    [{'radius': 20.0,
+      'rim_thickness': 10.0,
+      'face_thickness': 10.0,
+      'length': 400.0,
+      'core_sld': 1.0,
+      'face_sld': 4.0,
+      'rim_sld': 4.0,
+      'solvent_sld': 1.0,
+      'theta': 90.0,
+      'phi': 0.0,
+      'background': 0.00,
+     }, (qx, qy), 24.9167],
+
+    # Additional tests with larger range of parameters
+    [{'radius': 3.0,
+      'rim_thickness': 100.0,
+      'face_thickness': 100.0,
+      'length': 1200.0,
+      'core_sld': 5.0,
+      'face_sld': 41.0,
+      'rim_sld': 42.0,
+      'solvent_sld': 21.0,
+     }, 0.05, 1670.1828],
+    ]
Index: sasmodels/models/core_shell_ellipsoid.c
===================================================================
--- sasmodels/models/core_shell_ellipsoid.c	(revision 81dd61963c319ce8b1c38d14a6f3056a517fccdd)
+++ sasmodels/models/core_shell_ellipsoid.c	(revision 81dd61963c319ce8b1c38d14a6f3056a517fccdd)
@@ -0,0 +1,175 @@
+double form_volume(double equat_core,
+                   double polar_core,
+                   double equat_shell,
+                   double polar_shell);
+double Iq(double q,
+          double equat_core,
+          double polar_core,
+          double equat_shell,
+          double polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld);
+
+
+double Iqxy(double qx, double qy,
+          double equat_core,
+          double polar_core,
+          double equat_shell,
+          double polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld,
+          double theta,
+          double phi);
+
+
+double form_volume(double equat_core,
+                   double polar_core,
+                   double equat_shell,
+                   double polar_shell)
+{
+    double vol = 4.0*M_PI/3.0*equat_shell*equat_shell*polar_shell;
+    return vol;
+}
+
+static double
+core_shell_ellipsoid_kernel(double q,
+          double equat_core,
+          double polar_core,
+          double equat_shell,
+          double polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld)
+{
+	double delpc,delps;
+	double uplim,lolim;		//upper and lower integration limits
+	double summ,zi,yyy,answer; //running tally of integration
+
+	lolim = 0.0;
+	uplim = 1.0;
+
+	summ = 0.0;	 //initialize intergral
+
+	delpc = core_sld - shell_sld; //core - shell
+	delps = shell_sld - solvent_sld; //shell - solvent
+
+	for(int i=0;i<76;i++) {
+		zi = ( Gauss76Z[i]*(uplim-lolim) + uplim + lolim )/2.0;
+		yyy = Gauss76Wt[i] * gfn4(zi,
+		                          equat_core,
+		                          polar_core,
+		                          equat_shell,
+		                          polar_shell,
+		                          delpc,
+		                          delps,
+		                          q);
+		summ += yyy;
+	}
+
+	answer = (uplim-lolim)/2.0*summ;
+
+	//convert to [cm-1]
+	answer *= 1.0e-4;
+
+	return answer;
+}
+
+static double
+core_shell_ellipsoid_kernel_2d(double q, double q_x, double q_y,
+          double equat_core,
+          double polar_core,
+          double equat_shell,
+          double polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld,
+          double theta,
+          double phi)
+{
+    double cyl_x, cyl_y;
+    double cos_val;
+    double answer;
+    double sldcs,sldss;
+
+    //convert angle degree to radian
+    theta = theta * M_PI/180.0;
+    phi = phi * M_PI/180.0;
+
+
+    // ellipsoid orientation, the axis of the rotation is consistent with the ploar axis.
+    cyl_x = cos(theta) * cos(phi);
+    cyl_y = sin(theta);
+
+    sldcs = core_sld - shell_sld;
+    sldss = shell_sld- solvent_sld;
+
+    // Compute the angle btw vector q and the
+    // axis of the cylinder
+    cos_val = cyl_x*q_x + cyl_y*q_y;
+
+    // Call the IGOR library function to get the kernel: MUST use gfn4 not gf2 because of the def of params.
+    answer = gfn4(cos_val,
+                  equat_core,
+                  polar_core,
+                  equat_shell,
+                  polar_shell,
+                  sldcs,
+                  sldss,
+                  q);
+
+    //convert to [cm-1]
+    answer *= 1.0e-4;
+
+    return answer;
+}
+
+double Iq(double q,
+          double equat_core,
+          double polar_core,
+          double equat_shell,
+          double polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld)
+{
+    double intensity = core_shell_ellipsoid_kernel(q,
+           equat_core,
+           polar_core,
+           equat_shell,
+           polar_shell,
+           core_sld,
+           shell_sld,
+           solvent_sld);
+
+    return intensity;
+}
+
+
+double Iqxy(double qx, double qy,
+          double equat_core,
+          double polar_core,
+          double equat_shell,
+          double polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld,
+          double theta,
+          double phi)
+{
+    double q;
+    q = sqrt(qx*qx+qy*qy);
+    double intensity = core_shell_ellipsoid_kernel_2d(q, qx/q, qy/q,
+                       equat_core,
+                       polar_core,
+                       equat_shell,
+                       polar_shell,
+                       core_sld,
+                       shell_sld,
+                       solvent_sld,
+                       theta,
+                       phi);
+
+    return intensity;
+}
Index: sasmodels/models/core_shell_ellipsoid.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid.py	(revision 177c1a138481a9833b4929af687e86583b5c16d5)
+++ sasmodels/models/core_shell_ellipsoid.py	(revision 177c1a138481a9833b4929af687e86583b5c16d5)
@@ -0,0 +1,179 @@
+r"""
+This model provides the form factor, $P(q)$, for a core shell ellipsoid (below)
+where the form factor is normalized by the volume of the cylinder.
+
+.. math::
+
+    P(q) = scale * \left<f^2\right>/V + background
+
+where the volume $V = (4/3)\pi(r_{maj}r_{min}^2)$ and the averaging $< >$ is
+applied over all orientations for 1D.
+
+.. figure:: img/core_shell_ellipsoid_fig1.gif
+
+    The returned value is in units of $cm^{-1}$, on absolute scale.
+
+Definition
+----------
+
+The form factor calculated is
+
+.. math::
+
+    P(q) = \frac{scale}{V}\int_0^1
+        \left|F(q,r_{min},r_{max},\alpha)\right|^2d\alpha + background
+
+    \left|F(q,r_{min},r_{max},\alpha)\right|=V\Delta \rho \cdot (3j_1(u)/u)
+
+    u = q\left[ r_{maj}^2\alpha ^2 + r_{min}^2(1-\alpha ^2)\right]^{1/2}
+
+where
+
+.. math::
+
+    j_1(u)=(\sin x - x \cos x)/x^2
+
+To provide easy access to the orientation of the core-shell ellipsoid,
+we define the axis of the solid ellipsoid using two angles $\theta$ and $\phi$.
+These angles are defined on Figure 2 of the CylinderModel.
+The contrast is defined as SLD(core) - SLD(shell) and SLD(shell) - SLD(solvent).
+
+In the parameters, *equat_core* = equatorial core radius, *polar_core* =
+polar core radius, *equat_shell* = $r_{min}$ (or equatorial outer radius),
+and *polar_shell* = $r_{maj}$ (or polar outer radius).
+
+.. note::
+    The 2nd virial coefficient of the solid ellipsoid is calculated based on
+    the *radius_a* (= *polar_shell)* and *radius_b (= equat_shell)* values,
+    and used as the effective radius for *S(Q)* when $P(Q) * S(Q)$ is applied.
+
+.. figure:: img/core_shell_ellipsoid_1d.jpg
+
+    1D plot using the default values (w/200 data point).
+
+.. figure:: img/core_shell_ellipsoid_fig2.jpg
+
+    The angles for oriented core_shell_ellipsoid.
+
+Our model uses the form factor calculations implemented in a c-library provided
+by the NIST Center for Neutron Research (Kline, 2006).
+
+References
+----------
+
+M Kotlarchyk, S H Chen, *J. Chem. Phys.*, 79 (1983) 2461
+
+S J Berr, *Phys. Chem.*, 91 (1987) 4760
+
+"""
+
+from numpy import inf, sin, cos, pi
+
+name = "core_shell_ellipsoid"
+title = "Form factor for an spheroid ellipsoid particle with a core shell structure."
+description = """
+    [SpheroidCoreShellModel] Calculates the form factor for an spheroid
+    ellipsoid particle with a core_shell structure.
+    The form factor is averaged over all possible
+    orientations of the ellipsoid such that P(q)
+    = scale*<f^2>/Vol + bkg, where f is the
+    single particle scattering amplitude.
+    [Parameters]:
+    equat_core = equatorial radius of core,
+    polar_core = polar radius of core,
+    equat_shell = equatorial radius of shell,
+    polar_shell = polar radius (revolution axis) of shell,
+    core_sld = SLD_core
+    shell_sld = SLD_shell
+    solvent_sld = SLD_solvent
+    background = Incoherent bkg
+    scale =scale
+    Note:It is the users' responsibility to ensure
+    that shell radii are larger than core radii.
+    oblate: polar radius < equatorial radius
+    prolate :  polar radius > equatorial radius
+    """
+category = "shape:ellipsoid"
+
+single = False  # TODO: maybe using sph_j1c inside gfn would help?
+# pylint: disable=bad-whitespace, line-too-long
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [
+    ["equat_core",  "Ang",      200,   [0, inf],    "volume",      "Equatorial radius of core"],
+    ["polar_core",  "Ang",       10,   [0, inf],    "volume",      "Polar radius of core"],
+    ["equat_shell", "Ang",      250,   [0, inf],    "volume",      "Equatorial radius of shell"],
+    ["polar_shell", "Ang",       30,   [0, inf],    "volume",      "Polar radius of shell"],
+    ["core_sld",    "1e-6/Ang^2", 2,   [-inf, inf], "",            "Core scattering length density"],
+    ["shell_sld",   "1e-6/Ang^2", 1,   [-inf, inf], "",            "Shell scattering length density"],
+    ["solvent_sld", "1e-6/Ang^2", 6.3, [-inf, inf], "",            "Solvent scattering length density"],
+    ["theta",       "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation wrt incoming beam"],
+    ["phi",         "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation in the plane of the detector"],
+    ]
+# pylint: enable=bad-whitespace, line-too-long
+
+source = ["lib/sph_j1c.c", "lib/gfn.c", "lib/gauss76.c", "core_shell_ellipsoid.c"]
+
+demo = dict(scale=1, background=0.001,
+            equat_core=200.0,
+            polar_core=10.0,
+            equat_shell=250.0,
+            polar_shell=30.0,
+            core_sld=2.0,
+            shell_sld=1.0,
+            solvent_sld=6.3,
+            theta=0,
+            phi=0)
+
+oldname = 'CoreShellEllipsoidModel'
+
+oldpars = dict(core_sld='sld_core',
+               shell_sld='sld_shell',
+               solvent_sld='sld_solvent',
+               theta='axis_theta',
+               phi='axis_phi')
+
+q = 0.1
+phi = pi/6
+qx = q*cos(phi)
+qy = q*sin(phi)
+
+tests = [
+    # Accuracy tests based on content in test/utest_other_models.py
+    [{'equat_core': 200.0,
+      'polar_core': 20.0,
+      'equat_shell': 250.0,
+      'polar_shell': 30.0,
+      'core_sld': 2.0,
+      'shell_sld': 1.0,
+      'solvent_sld': 6.3,
+      'background': 0.001,
+      'scale': 1.0,
+     }, 1.0, 0.00189402],
+
+    # Additional tests with larger range of parameters
+    [{'background': 0.01}, 0.1, 8.86741],
+
+    [{'equat_core': 20.0,
+      'polar_core': 200.0,
+      'equat_shell': 54.0,
+      'polar_shell': 3.0,
+      'core_sld': 20.0,
+      'shell_sld': 10.0,
+      'solvent_sld': 6.0,
+      'background': 0.0,
+      'scale': 1.0,
+     }, 0.01, 26150.4],
+
+    [{'background': 0.001}, (0.4, 0.5), 0.00170471],
+
+    [{'equat_core': 20.0,
+      'polar_core': 200.0,
+      'equat_shell': 54.0,
+      'polar_shell': 3.0,
+      'core_sld': 20.0,
+      'shell_sld': 10.0,
+      'solvent_sld': 6.0,
+      'background': 0.01,
+      'scale': 0.01,
+     }, (qx, qy), 0.105764],
+    ]
Index: sasmodels/models/core_shell_ellipsoid_xt.c
===================================================================
--- sasmodels/models/core_shell_ellipsoid_xt.c	(revision 81bb6683df7d596fa70869ba742026b60f836b22)
+++ sasmodels/models/core_shell_ellipsoid_xt.c	(revision 81bb6683df7d596fa70869ba742026b60f836b22)
@@ -0,0 +1,190 @@
+double form_volume(double equat_core,
+                   double polar_core,
+                   double equat_shell,
+                   double polar_shell);
+double Iq(double q,
+          double equat_core,
+          double x_core,
+          double t_shell,
+          double x_polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld);
+
+
+double Iqxy(double qx, double qy,
+          double equat_core,
+          double x_core,
+          double t_shell,
+          double x_polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld,
+          double theta,
+          double phi);
+
+
+double form_volume(double equat_core,
+                   double x_core,
+                   double t_shell,
+                   double x_polar_shell)
+{
+	double equat_shell, polar_shell;
+    equat_shell = equat_core + t_shell;
+    polar_shell = equat_core*x_core + t_shell*x_polar_shell;
+    double vol = 4.0*M_PI/3.0*equat_shell*equat_shell*polar_shell;
+    return vol;
+}
+
+static double
+core_shell_ellipsoid_xt_kernel(double q,
+          double equat_core,
+          double x_core,
+          double t_shell,
+          double x_polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld)
+{
+	double delpc,delps;
+	double uplim,lolim;		//upper and lower integration limits
+	double summ,zi,yyy,answer; //running tally of integration
+	double polar_core, equat_shell, polar_shell;
+
+	lolim = 0.0;
+	uplim = 1.0;
+
+	summ = 0.0;	 //initialize intergral
+
+	delpc = core_sld - shell_sld; //core - shell
+	delps = shell_sld - solvent_sld; //shell - solvent
+
+
+    polar_core = equat_core*x_core;
+    equat_shell = equat_core + t_shell;
+    polar_shell = equat_core*x_core + t_shell*x_polar_shell;
+
+	for(int i=0;i<76;i++) {
+		zi = ( Gauss76Z[i]*(uplim-lolim) + uplim + lolim )/2.0;
+		yyy = Gauss76Wt[i] * gfn4(zi,
+		                          equat_core,
+                                  polar_core,
+                                  equat_shell,
+                                  polar_shell,
+		                          delpc,
+		                          delps,
+		                          q);
+		summ += yyy;
+	}
+
+	answer = (uplim-lolim)/2.0*summ;
+
+	//convert to [cm-1]
+	answer *= 1.0e-4;
+
+	return answer;
+}
+
+static double
+core_shell_ellipsoid_xt_kernel_2d(double q, double q_x, double q_y,
+          double equat_core,
+          double x_core,
+          double t_shell,
+          double x_polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld,
+          double theta,
+          double phi)
+{
+    double cyl_x, cyl_y;
+    double cos_val;
+    double answer;
+    double sldcs,sldss;
+	double polar_core, equat_shell, polar_shell;
+
+    //convert angle degree to radian
+    theta = theta * M_PI/180.0;
+    phi = phi * M_PI/180.0;
+
+
+    // ellipsoid orientation, the axis of the rotation is consistent with the ploar axis.
+    cyl_x = cos(theta) * cos(phi);
+    cyl_y = sin(theta);
+
+    sldcs = core_sld - shell_sld;
+    sldss = shell_sld- solvent_sld;
+
+    // Compute the angle btw vector q and the
+    // axis of the cylinder
+    cos_val = cyl_x*q_x + cyl_y*q_y;
+
+    polar_core = equat_core*x_core;
+    equat_shell = equat_core + t_shell;
+    polar_shell = equat_core*x_core + t_shell*x_polar_shell;
+
+    // Call the IGOR library function to get the kernel:
+    // MUST use gfn4 not gf2 because of the def of params.
+    answer = gfn4(cos_val,
+                  equat_core,
+                  polar_core,
+                  equat_shell,
+                  polar_shell,
+                  sldcs,
+                  sldss,
+                  q);
+
+    //convert to [cm-1]
+    answer *= 1.0e-4;
+
+    return answer;
+}
+
+double Iq(double q,
+          double equat_core,
+          double x_core,
+          double t_shell,
+          double x_polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld)
+{
+    double intensity = core_shell_ellipsoid_xt_kernel(q,
+           equat_core,
+           x_core,
+           t_shell,
+           x_polar_shell,
+           core_sld,
+           shell_sld,
+           solvent_sld);
+
+    return intensity;
+}
+
+
+double Iqxy(double qx, double qy,
+          double equat_core,
+          double x_core,
+          double t_shell,
+          double x_polar_shell,
+          double core_sld,
+          double shell_sld,
+          double solvent_sld,
+          double theta,
+          double phi)
+{
+    double q;
+    q = sqrt(qx*qx+qy*qy);
+    double intensity = core_shell_ellipsoid_xt_kernel_2d(q, qx/q, qy/q,
+                       equat_core,
+                       x_core,
+                       t_shell,
+                       x_polar_shell,
+                       core_sld,
+                       shell_sld,
+                       solvent_sld,
+                       theta,
+                       phi);
+
+    return intensity;
+}
Index: sasmodels/models/core_shell_ellipsoid_xt.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid_xt.py	(revision 3882eeb5b3de1f8eff75651cb6dcd8f9dba766d6)
+++ sasmodels/models/core_shell_ellipsoid_xt.py	(revision 3882eeb5b3de1f8eff75651cb6dcd8f9dba766d6)
@@ -0,0 +1,172 @@
+r"""
+An alternative version of $P(q)$ for the core-shell ellipsoid
+(see CoreShellEllipsoidModel), having as parameters the core axial ratio X
+and a shell thickness, which are more often what we would like to determine.
+
+This model is also better behaved when polydispersity is applied than the four
+independent radii in CoreShellEllipsoidModel.
+
+Definition
+----------
+
+.. figure:: img/core_shell_ellipsoid_fig1.gif
+
+
+The geometric parameters of this model are
+
+*equat_core =* equatorial core radius *= R_minor_core*
+
+*X_core = polar_core / equat_core = Rmajor_core / Rminor_core*
+
+*T_shell = equat_outer - equat_core = Rminor_outer - Rminor_core*
+
+*XpolarShell = Tpolar_shell / T_shell = (Rmajor_outer - Rmajor_core)/
+(Rminor_outer - Rminor_core)*
+
+In terms of the original radii
+
+*polar_core = equat_core * X_core*
+
+*equat_shell = equat_core + T_shell*
+
+*polar_shell = equat_core * X_core + T_shell * XpolarShell*
+
+(where we note that "shell" perhaps confusingly, relates to the outer radius)
+When *X_core < 1* the core is oblate; when *X_core > 1* it is prolate.
+*X_core = 1* is a spherical core.
+
+For a fixed shell thickness *XpolarShell = 1*, to scale the shell thickness
+pro-rata with the radius *XpolarShell = X_core*.
+
+When including an $S(q)$, the radius in $S(q)$ is calculated to be that of
+a sphere with the same 2nd virial coefficient of the outer surface of the
+ellipsoid. This may have some undesirable effects if the aspect ratio of the
+ellipsoid is large (ie, if $X << 1$ or $X >> 1$ ), when the $S(q)$
+- which assumes spheres - will not in any case be valid.
+
+If SAS data are in absolute units, and the SLDs are correct, then scale should
+be the total volume fraction of the "outer particle". When $S(q)$ is introduced
+this moves to the $S(q)$ volume fraction, and scale should then be 1.0,
+or contain some other units conversion factor (for example, if you have SAXS data).
+
+References
+----------
+
+R K Heenan, *Private communication*
+
+"""
+
+from numpy import inf, sin, cos, pi
+
+name = "core_shell_ellipsoid_xt"
+title = "Form factor for an spheroid ellipsoid particle with a core shell structure."
+description = """
+        [core_shell_ellipsoid_xt] Calculates the form factor for an spheroid
+        ellipsoid particle with a core_shell structure.
+        The form factor is averaged over all possible
+        orientations of the ellipsoid such that P(q)
+        = scale*<f^2>/Vol + bkg, where f is the
+        single particle scattering amplitude.
+        [Parameters]:
+        equat_core = equatorial radius of core,
+        x_core = polar radius of core,
+        t_shell = equatorial radius of outer surface,
+        x_polar_shell = polar radius (revolution axis) of outer surface
+        core_sld = SLD_core
+        shell_sld = SLD_shell
+        solvent_sld = SLD_solvent
+        background = Incoherent bkg
+        scale =scale
+        Note:It is the users' responsibility to ensure
+        that shell radii are larger than core radii.
+        oblate: polar radius < equatorial radius
+        prolate :  polar radius > equatorial radius - this new model will make this easier
+        and polydispersity integrals more logical (as previously the shell could disappear).
+    """
+category = "shape:ellipsoid"
+
+# pylint: disable=bad-whitespace, line-too-long
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [
+    ["equat_core",    "Ang",       20,   [0, inf],    "volume",      "Equatorial radius of core"],
+    ["x_core",        "None",       3,   [0, inf],    "volume",      "Polar radius of core"],
+    ["t_shell",       "Ang",       30,   [0, inf],    "volume",      "Equatorial radius of shell"],
+    ["x_polar_shell", "",           1,   [0, inf],    "volume",      "Polar radius of shell"],
+    ["core_sld",      "1e-6/Ang^2", 2,   [-inf, inf], "",            "Core scattering length density"],
+    ["shell_sld",     "1e-6/Ang^2", 1,   [-inf, inf], "",            "Shell scattering length density"],
+    ["solvent_sld",   "1e-6/Ang^2", 6.3, [-inf, inf], "",            "Solvent scattering length density"],
+    ["theta",         "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation wrt incoming beam"],
+    ["phi",           "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation in the plane of the detector"],
+    ]
+# pylint: enable=bad-whitespace, line-too-long
+
+source = ["lib/sph_j1c.c", "lib/gfn.c", "lib/gauss76.c",
+          "core_shell_ellipsoid_xt.c"]
+
+demo = dict(scale=0.05, background=0.001,
+            equat_core=20.0,
+            x_core=3.0,
+            t_shell=30.0,
+            x_polar_shell=1.0,
+            core_sld=2.0,
+            shell_sld=1.0,
+            solvent_sld=6.3,
+            theta=0,
+            phi=0)
+
+oldname = 'CoreShellEllipsoidXTModel'
+
+oldpars = dict(x_polar_shell='XpolarShell',
+               x_core='X_core',
+               t_shell='T_shell',
+               core_sld='sld_core',
+               shell_sld='sld_shell',
+               solvent_sld='sld_solvent',
+               theta='axis_theta',
+               phi='axis_phi')
+
+q = 0.1
+phi = pi/6
+qx = q*cos(phi)
+qy = q*sin(phi)
+
+tests = [
+    # Accuracy tests based on content in test/utest_coreshellellipsoidXTmodel.py
+    [{'equat_core': 200.0,
+      'x_core': 0.1,
+      't_shell': 50.0,
+      'x_polar_shell': 0.2,
+      'core_sld': 2.0,
+      'shell_sld': 1.0,
+      'solvent_sld': 6.3,
+      'background': 0.001,
+      'scale': 1.0,
+     }, 1.0, 0.00189402],
+
+    # Additional tests with larger range of parameters
+    [{'background': 0.01}, 0.1, 11.6915],
+
+    [{'equat_core': 20.0,
+      'x_core': 200.0,
+      't_shell': 54.0,
+      'x_polar_shell': 3.0,
+      'core_sld': 20.0,
+      'shell_sld': 10.0,
+      'solvent_sld': 6.0,
+      'background': 0.0,
+      'scale': 1.0,
+     }, 0.01, 8688.53],
+
+    [{'background': 0.001}, (0.4, 0.5), 0.00690673],
+
+    [{'equat_core': 20.0,
+      'x_core': 200.0,
+      't_shell': 54.0,
+      'x_polar_shell': 3.0,
+      'core_sld': 20.0,
+      'shell_sld': 10.0,
+      'solvent_sld': 6.0,
+      'background': 0.01,
+      'scale': 0.01,
+     }, (qx, qy), 0.0100002],
+    ]
